#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Controlador encargado de la gestion del presupuesto detallado de un presupuesto. Sus metodos se invocan via ajax al elaborar el presupuesto por proyecto o por agente.
#
class PresupuestoDetalladoController < ApplicationController

  # en proyectos: prepara el formulario para los detalles del presupuesto
  def editar
    @presupuesto = Presupuesto.find params[:id]
    @presupuesto_detallados = Presupuesto.find(params[:id]).presupuesto_detallado
    @fecha_inicio = @presupuesto.etapa.fecha_inicio if @presupuesto.etapa
    @fecha_fin = @presupuesto.etapa.fecha_fin if @presupuesto.etapa
    render :partial => "presupuesto_detallado"
  end

  # en proyectos:	guarda el detalle de presupuesto
  def guardar
    @objeto = Presupuesto.find(params[:id])
    @objeto.actualizar_presupuesto_detallado params[:detalle]
    render :template => "presupuesto_detallado/mensaje_formulario"
  end

  # en proyectos: divide el detalle de presupuesto por meses
  def dividir_x_mes
    @presupuesto = Presupuesto.find params[:id]
    @presupuesto.presupuesto_detallado.clear
    @fecha_inicio = @presupuesto.etapa.fecha_inicio
    @fecha_fin = @presupuesto.etapa.fecha_fin
    @presupuesto.dividir_por_mes @fecha_inicio, @fecha_fin
    @presupuesto_detallados = Presupuesto.find(params[:id]).presupuesto_detallado
    render :partial => "presupuesto_detallado"
  end

end
