#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# fuente de verificación

class FuenteVerificacion < ActiveRecord::Base
  belongs_to :indicador
  belongs_to :objetivo_especifico
  belongs_to :resultado

  has_many :fuente_verificacion_x_documento
  has_many :documento, :through => :fuente_verificacion_x_documento

  validate :codigo_mayusculas
  validates_presence_of :codigo, :message => _("Código") + _(" no pueden estar vacío.")
  validates_presence_of :descripcion, :message => _("Descripcion") + _(" no pueden estar vacío.")
  validates_uniqueness_of :codigo, :scope => [:objetivo_especifico_id, :resultado_id], :message => _("Código") + _(" repetido.")

  def codigo_mayusculas
    self.codigo = self.codigo.upcase
  end

  def objetivo_resultado
    if !(objetivo_especifico.nil?); "(Objetivo) " + objetivo_especifico.codigo_nombre;
    elsif !(resultado.nil?); "(Resultado) " + resultado.codigo_nombre;
    else "";
    end
  end
end
