#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
class ProyectoXProyecto < ActiveRecord::Base
  belongs_to :proyecto_cofinanciado, :foreign_key => "proyecto_id", :class_name => "Proyecto"
  belongs_to :proyecto_cofinanciador, :class_name => "Proyecto"


  # Evita que se repitan asociaciones
  validates_uniqueness_of :proyecto_cofinanciador_id, :scope => :proyecto_id, :message => _("El proyecto ya está asociado")
  # Evita que se vincule con sigo mismo
  validate :no_soy_yo

  def no_soy_yo
    errors.add(:base, _("No se puede asociar un proyecto a si mismo") ) if proyecto_id == proyecto_cofinanciador_id
  end
end

