#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
class VPresupuesto < ActiveRecord::Base

  named_scope :partida_implementador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, implementador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }

  named_scope :partida_financiador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, financiador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, financiador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }

  named_scope :actividad_implementador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, implementador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} actividad_id, implementador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }

                                    
  named_scope :actividad_financiador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, financiador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} actividad_id, financiador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2]) } }

  named_scope :partida_proyecto_implementador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, implementador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_proyecto_id, implementador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }

                                    
  named_scope :partida_proyecto_financiador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, financiador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_proyecto_id, financiador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2]) } }
     
  named_scope :financiador, lambda { |*valores| {
                                 :select => "#{importe 'todas', '1' } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => {"proyecto_id" => valores[0], "financiador_id" => valores[1] }  } }

  named_scope :subpartida_partida, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida => valores[4], :subpartida => (valores[5] || "isnull") ) } }

  named_scope :subpartida_partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida_proyecto => valores[4], :subpartida => (valores[5] || "isnull") ) } }

  named_scope :partida, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida => valores[4] ) } }

  named_scope :partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida_proyecto => valores[4] ) } }

  def self.importe moneda_id, tasa_cambio
    importe = if  moneda_id == "todas";  "sum(importe_moneda_base)"
               elsif tasa_cambio == "0"; "sum(importe)"
               elsif tasa_cambio == "1"; "sum(importe_moneda_base)"; end
  end  

  def self.condiciones proyecto_id, etapa_id, moneda_id, otros={}
     condiciones = {"proyecto_id" => proyecto_id, "etapa_id" => etapa_id }
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones["partida_id"] = otros[:partida] if otros[:partida]
     condiciones["partida_proyecto_id"] = otros[:partida_proyecto] if otros[:partida_proyecto]
     condiciones["subpartida_id"] = otros[:subpartida] if otros[:subpartida]
     condiciones["subpartida_id"] = nil if otros[:subpartida] == "isnull"
     return condiciones
  end

end
