class MigracionDatoProyecto < ActiveRecord::Migration
  def self.up
    proyectos = Proyecto.all
    i = 0
    [["Codigo de la Organización", "codigo_de_la_organizacion"],
      ["Codigo del Financiador", "codigo_del_financiador"],
      ["Breve Descripción", "breve_descripcion"],
      ["Descripción Extensa", "descripcion_extensa"],
      ["Análisis razonado de la acción", "analisis_razonado_de_la_accion"],
      ["Contenidos e ideas que difunde el proyecto", "contenidos_e_ideas_que_difunde_el_proyecto"],
      ["Adecuación a los principios horizontales", "adecuacion_a_los_principios_horizontales"],
      ["Descripción de la metodología", "descripcion_de_la_metodologia"],
      ["Plan de Difusión", "plan_de_difusion"],
      ["Materiales y soportes", "materiales_y_soportes"]].each do |d|
        definicion_dato = DefinicionDato.create( :nombre => d[1], :rotulo => d[0], :tipo => "Texto", :pestana => "identificacion", :rango => i ) 
        proyectos.each do |proyecto|
          if proyecto.datos_proyecto
            DatoTexto.create(:dato => proyecto.datos_proyecto.send(d[1]), :proyecto_id => proyecto.id, :definicion_dato_id => definicion_dato.id) unless proyecto.datos_proyecto.send(d[1]).nil?
          end
        end
        i += 1
    end
    i=0
    [["Descripción Población beneficiaria", "descripcion_poblacion_beneficiaria"],
      ["Ubicación detallada de la zona de Proyecto", "ubicacion_detallada_de_la_zona_de_proyecto"],
      ["Principales problemas comunes detectados", "principales_problemas_comunes_detectados"],
      ["Principales problemas específicos detectados", "principales_problemas_especificos_detectados"],
      ["Experiencia de la ONG y contrapartes en la zona/s y en el sector/es", "experiencia_de_la_ong_y_contrapartes"],
      ["Normativa Relativa a ONGD de obligado cumplimiento en el País de implementación", "normativa_relativa_a_ongd_de_obligado_cumplimiento"],
      ["Grado de Participación de Beneficiarios Directos en la formulación", "grado_de_participacion_de_beneficiarios_directos"],
      ["Complementariedad y sinergia con la política española de cooperación", "complementariedad_y_sinergia"],
      ["Organismos Públicos o privados implicados", "organismos_publicos_o_privados_implicados"],
      ["Socios Locales", "socios_locales"],
      ["Población beneficiaria", "poblacion_beneficiaria"],
      ["Acuerdos y compromisos firmados", "acuerdos_y_compromisos_firmados"]].each do |d|
        definicion_dato = DefinicionDato.create( :nombre => d[1], :rotulo => d[0], :tipo => "Texto", :pestana => "contexto", :rango => i ) 
        proyectos.each do |proyecto|
          if proyecto.datos_proyecto
            DatoTexto.create(:dato => proyecto.datos_proyecto.send(d[1]), :proyecto_id => proyecto.id, :definicion_dato_id => definicion_dato.id) unless proyecto.datos_proyecto.send(d[1]).nil?
          end
        end
        i += 1
    end
    i = 0
    [["Objetivos que se abordan", "objetivos_que_se_abordan"],
      ["Justificación de la Estrategia de Intervención", "justificacion_de_la_estrategia_de_intervencion"],
      ["Objetivo de desarrollo. Resumen Descriptivo", "objetivo_de_desarrollo_resumen_descriptivo"],
      ["Objetivo de desarrollo. Factores de riesgo e hipótesis Personal", "objetivo_de_desarrollo_factores_de_riesgo_e_hipotesis_personal"],
      ["Factores de Desarrollo. Políticas de Apoyo", "factores_de_desarrollo_politicas_de_apoyo"],
      ["Factores de Desarrollo. Aspectos institucionales", "factores_de_desarrollo_aspectos_institucionales"],
      ["Factores de Desarrollo. Aspectos Socioculturales", "factores_de_desarrollo_aspectos_socioculturales"],
      ["Factores de Desarrollo. Enfoque de Género", "factores_de_desarrollo_enfoque_de_genero"],
      ["Factores de Desarrollo. Factores Medioambientales", "factores_de_desarrollo_factores_medioambientales"],
      ["Factores de Desarrollo. Factores Económico Financieros", "factores_de_desarrollo_factores_economico_financieros"],
      ["Sostenibilidad de la Intervención y Procedimiento de Transferencia previstos", "sostenibilidad_de_la_intervencion"]].each do |d|
          definicion_dato = DefinicionDato.create( :nombre => d[1], :rotulo => d[0], :tipo => "Texto", :pestana => "objetivos", :rango => i ) 
        proyectos.each do |proyecto|
          if proyecto.datos_proyecto
            DatoTexto.create(:dato => proyecto.datos_proyecto.send(d[1]), :proyecto_id => proyecto.id, :definicion_dato_id => definicion_dato.id) unless proyecto.datos_proyecto.send(d[1]).nil?
          end
        end
        i += 1
    end
    remove_column :datos_proyecto, :codigo_de_la_organizacion
    remove_column :datos_proyecto, :codigo_del_financiador
    remove_column :datos_proyecto, :breve_descripcion
    remove_column :datos_proyecto, :descripcion_extensa
    remove_column :datos_proyecto, :analisis_razonado_de_la_accion
    remove_column :datos_proyecto, :contenidos_e_ideas_que_difunde_el_proyecto
    remove_column :datos_proyecto, :adecuacion_a_los_principios_horizontales
    remove_column :datos_proyecto, :descripcion_de_la_metodologia
    remove_column :datos_proyecto, :plan_de_difusion
    remove_column :datos_proyecto, :materiales_y_soportes
    remove_column :datos_proyecto, :descripcion_poblacion_beneficiaria
    remove_column :datos_proyecto, :ubicacion_detallada_de_la_zona_de_proyecto
    remove_column :datos_proyecto, :principales_problemas_comunes_detectados
    remove_column :datos_proyecto, :principales_problemas_especificos_detectados
    remove_column :datos_proyecto, :experiencia_de_la_ong_y_contrapartes
    remove_column :datos_proyecto, :normativa_relativa_a_ongd_de_obligado_cumplimiento
    remove_column :datos_proyecto, :grado_de_participacion_de_beneficiarios_directos
    remove_column :datos_proyecto, :complementariedad_y_sinergia
    remove_column :datos_proyecto, :organismos_publicos_o_privados_implicados
    remove_column :datos_proyecto, :socios_locales
    remove_column :datos_proyecto, :poblacion_beneficiaria
    remove_column :datos_proyecto, :acuerdos_y_compromisos_firmados
    remove_column :datos_proyecto, :objetivos_que_se_abordan
    remove_column :datos_proyecto, :justificacion_de_la_estrategia_de_intervencion
    remove_column :datos_proyecto, :objetivo_de_desarrollo_resumen_descriptivo
    remove_column :datos_proyecto, :objetivo_de_desarrollo_factores_de_riesgo_e_hipotesis_personal
    remove_column :datos_proyecto, :factores_de_desarrollo_politicas_de_apoyo
    remove_column :datos_proyecto, :factores_de_desarrollo_aspectos_institucionales
    remove_column :datos_proyecto, :factores_de_desarrollo_aspectos_socioculturales
    remove_column :datos_proyecto, :factores_de_desarrollo_enfoque_de_genero
    remove_column :datos_proyecto, :factores_de_desarrollo_factores_medioambientales
    remove_column :datos_proyecto, :factores_de_desarrollo_factores_economico_financieros
    remove_column :datos_proyecto, :sostenibilidad_de_la_intervencion
  end
end

