class CambiosEnInformes < ActiveRecord::Migration
  def self.up
  		self.down
  
  				    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_etapa_diff_meses` AS 

select period_diff(date_format(e.fecha_inicio,'%Y%m'),date_format(e2.fecha_inicio,'%Y%m')) AS diff_meses,
e.id AS id,e.nombre AS nombre,e.fecha_inicio AS fecha_inicio,e.fecha_fin AS fecha_fin,e.descripcion AS descripcion,
e.proyecto_id AS proyecto_id,e.agente_id AS agente_id 
from etapa e 
inner join etapa e2 on e.proyecto_id = e2.proyecto_id 
where e2.fecha_inicio = (select min(etapa.fecha_inicio) from etapa where etapa.proyecto_id = e.proyecto_id)
;
		__EOI
		
				    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_fechas_informe_aecid` AS 

select P.id as proyecto_id, 

(select etapa.id from etapa where 
etapa.proyecto_id = P.id and 
etapa.fecha_inicio = (select min(etapa2.fecha_inicio) from etapa etapa2 where etapa2.proyecto_id = P.id)
) as E1_id,

(select min(etapa.fecha_inicio) from etapa where etapa.proyecto_id = P.id) as fecha_E1_ini,
(select min(etapa.fecha_fin) from etapa where etapa.proyecto_id = P.id) as fecha_E1_fin


,

(select etapa.id from etapa where 
etapa.proyecto_id = P.id and 
etapa.fecha_inicio > (select min(etapa2.fecha_inicio) from etapa etapa2 where etapa2.proyecto_id = P.id) and
etapa.fecha_inicio < (select max(etapa2.fecha_inicio) from etapa etapa2 where etapa2.proyecto_id = P.id) LIMIT 1
) as E2_id

,


(select min(etapa.fecha_inicio) from etapa where 
etapa.proyecto_id = P.id and 
etapa.fecha_inicio > (select min(etapa2.fecha_inicio) from etapa etapa2 where etapa2.proyecto_id = P.id)
) as fecha_E2_ini,

(select min(etapa.fecha_fin) from etapa where 
etapa.proyecto_id = P.id and 
etapa.fecha_inicio > (select min(etapa2.fecha_inicio) from etapa etapa2 where etapa2.proyecto_id = P.id)
)  as fecha_E2_fin


,

(select etapa.id from etapa where 
etapa.proyecto_id = P.id and 
etapa.fecha_inicio = (select max(etapa2.fecha_inicio) from etapa etapa2 where etapa2.proyecto_id = P.id)
) as E3_id,

(select max(etapa.fecha_inicio) from etapa where etapa.proyecto_id = P.id) as fecha_E3_ini,
(select max(etapa.fecha_fin) from etapa where etapa.proyecto_id = P.id) as fecha_E3_fin

from 
proyecto P
;
		__EOI
  
  
    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_cabecera_cronograma` AS 
select 
V.proyecto_id,
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 1   then 1   else '' end as   'M_1',     
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 2   then 2   else '' end as   'M_2',     
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 3   then 3   else '' end as   'M_3',     
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 4   then 4   else '' end as   'M_4',     
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 5   then 5   else '' end as   'M_5',     
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 6   then 6   else '' end as   'M_6',     
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 7   then 7   else '' end as   'M_7',     
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 8   then 8   else '' end as   'M_8',     
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 9   then 9   else '' end as   'M_9',     
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 10  then 10  else '' end as   'M_10',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 11  then 11  else '' end as   'M_11',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 12  then 12  else '' end as   'M_12',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 13  then 13  else '' end as   'M_13',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 14  then 14  else '' end as   'M_14',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 15  then 15  else '' end as   'M_15',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 16  then 16  else '' end as   'M_16',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 17  then 17  else '' end as   'M_17',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 18  then 18  else '' end as   'M_18',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 19  then 19  else '' end as   'M_19',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 20  then 20  else '' end as   'M_20',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 21  then 21  else '' end as   'M_21',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 22  then 22  else '' end as   'M_22',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 23  then 23  else '' end as   'M_23',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 24  then 24  else '' end as   'M_24',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 25  then 25  else '' end as   'M_25',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 26  then 26  else '' end as   'M_26',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 27  then 27  else '' end as   'M_27',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 28  then 28  else '' end as   'M_28',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 29  then 29  else '' end as   'M_29',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 30  then 30  else '' end as   'M_30',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 31  then 31  else '' end as   'M_31',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 32  then 32  else '' end as   'M_32',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 33  then 33  else '' end as   'M_33',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 34  then 34  else '' end as   'M_34',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 35  then 35  else '' end as   'M_35',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 36  then 36  else '' end as   'M_36',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 37  then 37  else '' end as   'M_37',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 38  then 38  else '' end as   'M_38',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 39  then 39  else '' end as   'M_39',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 40  then 40  else '' end as   'M_40',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 41  then 41  else '' end as   'M_41',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 42  then 42  else '' end as   'M_42',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 43  then 43  else '' end as   'M_43',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 44  then 44  else '' end as   'M_44',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 45  then 45  else '' end as   'M_45',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 46  then 46  else '' end as   'M_46',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 47  then 47  else '' end as   'M_47',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 48  then 48  else '' end as   'M_48',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 49  then 49  else '' end as   'M_49',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 50  then 50  else '' end as   'M_50',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 51  then 51  else '' end as   'M_51',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 52  then 52  else '' end as   'M_52',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 53  then 53  else '' end as   'M_53',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 54  then 54  else '' end as   'M_54',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 55  then 55  else '' end as   'M_55',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 56  then 56  else '' end as   'M_56',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 57  then 57  else '' end as   'M_57',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 58  then 58  else '' end as   'M_58',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 59  then 59  else '' end as   'M_59',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 60  then 60  else '' end as   'M_60',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 61  then 61  else '' end as   'M_61',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 62  then 62  else '' end as   'M_62',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 63  then 63  else '' end as   'M_63',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 64  then 64  else '' end as   'M_64',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 65  then 65  else '' end as   'M_65',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 66  then 66  else '' end as   'M_66',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 67  then 67  else '' end as   'M_67',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 68  then 68  else '' end as   'M_68',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 69  then 69  else '' end as   'M_69',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 70  then 70  else '' end as   'M_70',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 71  then 71  else '' end as   'M_71',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 72  then 72  else '' end as   'M_72',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 73  then 73  else '' end as   'M_73',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 74  then 74  else '' end as   'M_74',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 75  then 75  else '' end as   'M_75',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 76  then 76  else '' end as   'M_76',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 77  then 77  else '' end as   'M_77',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 78  then 78  else '' end as   'M_78',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 79  then 79  else '' end as   'M_79',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 80  then 80  else '' end as   'M_80',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 81  then 81  else '' end as   'M_81',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 82  then 82  else '' end as   'M_82',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 83  then 83  else '' end as   'M_83',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 84  then 84  else '' end as   'M_84',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 85  then 85  else '' end as   'M_85',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 86  then 86  else '' end as   'M_86',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 87  then 87  else '' end as   'M_87',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 88  then 88  else '' end as   'M_88',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 89  then 89  else '' end as   'M_89',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 90  then 90  else '' end as   'M_90',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 91  then 91  else '' end as   'M_91',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 92  then 92  else '' end as   'M_92',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 93  then 93  else '' end as   'M_93',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 94  then 94  else '' end as   'M_94',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 95  then 95  else '' end as   'M_95',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 96  then 96  else '' end as   'M_96',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 97  then 97  else '' end as   'M_97',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 98  then 98  else '' end as   'M_98',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 99  then 99  else '' end as   'M_99',    
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 100 then 100 else '' end as   'M_100',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 101 then 101 else '' end as   'M_101',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 102 then 102 else '' end as   'M_102',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 103 then 103 else '' end as   'M_103',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 104 then 104 else '' end as   'M_104',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 105 then 105 else '' end as   'M_105',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 106 then 106 else '' end as   'M_106',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 107 then 107 else '' end as   'M_107',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 108 then 108 else '' end as   'M_108',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 109 then 109 else '' end as   'M_109',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 110 then 110 else '' end as   'M_110',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 111 then 111 else '' end as   'M_111',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 112 then 112 else '' end as   'M_112',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 113 then 113 else '' end as   'M_113',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 114 then 114 else '' end as   'M_114',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 115 then 115 else '' end as   'M_115',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 116 then 116 else '' end as   'M_116',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 117 then 117 else '' end as   'M_117',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 118 then 118 else '' end as   'M_118',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 119 then 119 else '' end as   'M_119',   
case when  period_diff( date_format(IFNULL(V.fecha_E3_fin,V.fecha_E1_fin),'%Y%m'),date_format(V.fecha_E1_ini, '%Y%m'))+ 1 >= 120 then 120 else '' end as   'M_120'    
from 
proyecto P
inner join v_fechas_informe_aecid V on P.id = V.proyecto_id
;
		__EOI

    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_listado_resultados_actividades_cronograma_aecid` AS 



select 'Resultado' as Tipo,'Resultado' as tipo2,
concat(R.codigo ,' - ', R.descripcion) as nombre,R.id as resultado_id,'0' as actividad_id,R.proyecto_id,
'0'as   'M_1',   
'0'as   'M_2',   
'0'as   'M_3',   
'0'as   'M_4',   
'0'as   'M_5',   
'0'as   'M_6',   
'0'as   'M_7',   
'0'as   'M_8',   
'0'as   'M_9',   
'0'as   'M_10',  
'0'as   'M_11',  
'0'as   'M_12',  
'0'as   'M_13',  
'0'as   'M_14',  
'0'as   'M_15',  
'0'as   'M_16',  
'0'as   'M_17',  
'0'as   'M_18',  
'0'as   'M_19',  
'0'as   'M_20',  
'0'as   'M_21',  
'0'as   'M_22',  
'0'as   'M_23',  
'0'as   'M_24',  
'0'as   'M_25',  
'0'as   'M_26',  
'0'as   'M_27',  
'0'as   'M_28',  
'0'as   'M_29',  
'0'as   'M_30',  
'0'as   'M_31',  
'0'as   'M_32',  
'0'as   'M_33',  
'0'as   'M_34',  
'0'as   'M_35',  
'0'as   'M_36',  
'0'as   'M_37',  
'0'as   'M_38',  
'0'as   'M_39',  
'0'as   'M_40',  
'0'as   'M_41',  
'0'as   'M_42',  
'0'as   'M_43',  
'0'as   'M_44',  
'0'as   'M_45',  
'0'as   'M_46',  
'0'as   'M_47',  
'0'as   'M_48',  
'0'as   'M_49',  
'0'as   'M_50',  
'0'as   'M_51',  
'0'as   'M_52',  
'0'as   'M_53',  
'0'as   'M_54',  
'0'as   'M_55',  
'0'as   'M_56',  
'0'as   'M_57',  
'0'as   'M_58',  
'0'as   'M_59',  
'0'as   'M_60',  
'0'as   'M_61',  
'0'as   'M_62',  
'0'as   'M_63',  
'0'as   'M_64',  
'0'as   'M_65',  
'0'as   'M_66',  
'0'as   'M_67',  
'0'as   'M_68',  
'0'as   'M_69',  
'0'as   'M_70',  
'0'as   'M_71',  
'0'as   'M_72',  
'0'as   'M_73',  
'0'as   'M_74',  
'0'as   'M_75',  
'0'as   'M_76',  
'0'as   'M_77',  
'0'as   'M_78',  
'0'as   'M_79',  
'0'as   'M_80',  
'0'as   'M_81',  
'0'as   'M_82',  
'0'as   'M_83',  
'0'as   'M_84',  
'0'as   'M_85',  
'0'as   'M_86',  
'0'as   'M_87',  
'0'as   'M_88',  
'0'as   'M_89',  
'0'as   'M_90',  
'0'as   'M_91',  
'0'as   'M_92',  
'0'as   'M_93',  
'0'as   'M_94',  
'0'as   'M_95',  
'0'as   'M_96',  
'0'as   'M_97',  
'0'as   'M_98',  
'0'as   'M_99',  
'0'as   'M_100', 
'0'as   'M_101', 
'0'as   'M_102', 
'0'as   'M_103', 
'0'as   'M_104', 
'0'as   'M_105', 
'0'as   'M_106', 
'0'as   'M_107', 
'0'as   'M_108', 
'0'as   'M_109', 
'0'as   'M_110', 
'0'as   'M_111', 
'0'as   'M_112', 
'0'as   'M_113', 
'0'as   'M_114', 
'0'as   'M_115', 
'0'as   'M_116', 
'0'as   'M_117', 
'0'as   'M_118', 
'0'as   'M_119', 
'0'as   'M_120'  
 from resultado R

Union all




select 
'       ' as tipo,'Real' as tipo2, concat(A.codigo ,' - ', A.descripcion,'   ','(Real)') as nombre,A.resultado_id,A.id as actividad_id,A.proyecto_id,
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 1   then 1 else 0 end as   'M_1',     
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 2   then 1 else 0 end as   'M_2',     
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 3   then 1 else 0 end as   'M_3',     
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 4   then 1 else 0 end as   'M_4',     
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 5   then 1 else 0 end as   'M_5',     
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 6   then 1 else 0 end as   'M_6',     
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 7   then 1 else 0 end as   'M_7',     
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 8   then 1 else 0 end as   'M_8',     
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 9   then 1 else 0 end as   'M_9',     
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 10  then 1 else 0 end as   'M_10',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 11  then 1 else 0 end as   'M_11',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 12  then 1 else 0 end as   'M_12',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 13  then 1 else 0 end as   'M_13',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 14  then 1 else 0 end as   'M_14',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 15  then 1 else 0 end as   'M_15',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 16  then 1 else 0 end as   'M_16',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 17  then 1 else 0 end as   'M_17',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 18  then 1 else 0 end as   'M_18',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 19  then 1 else 0 end as   'M_19',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 20  then 1 else 0 end as   'M_20',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 21  then 1 else 0 end as   'M_21',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 22  then 1 else 0 end as   'M_22',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 23  then 1 else 0 end as   'M_23',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 24  then 1 else 0 end as   'M_24',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 25  then 1 else 0 end as   'M_25',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 26  then 1 else 0 end as   'M_26',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 27  then 1 else 0 end as   'M_27',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 28  then 1 else 0 end as   'M_28',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 29  then 1 else 0 end as   'M_29',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 30  then 1 else 0 end as   'M_30',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 31  then 1 else 0 end as   'M_31',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 32  then 1 else 0 end as   'M_32',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 33  then 1 else 0 end as   'M_33',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 34  then 1 else 0 end as   'M_34',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 35  then 1 else 0 end as   'M_35',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 36  then 1 else 0 end as   'M_36',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 37  then 1 else 0 end as   'M_37',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 38  then 1 else 0 end as   'M_38',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 39  then 1 else 0 end as   'M_39',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 40  then 1 else 0 end as   'M_40',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 41  then 1 else 0 end as   'M_41',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 42  then 1 else 0 end as   'M_42',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 43  then 1 else 0 end as   'M_43',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 44  then 1 else 0 end as   'M_44',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 45  then 1 else 0 end as   'M_45',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 46  then 1 else 0 end as   'M_46',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 47  then 1 else 0 end as   'M_47',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 48  then 1 else 0 end as   'M_48',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 49  then 1 else 0 end as   'M_49',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 50  then 1 else 0 end as   'M_50',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 51  then 1 else 0 end as   'M_51',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 52  then 1 else 0 end as   'M_52',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 53  then 1 else 0 end as   'M_53',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 54  then 1 else 0 end as   'M_54',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 55  then 1 else 0 end as   'M_55',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 56  then 1 else 0 end as   'M_56',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 57  then 1 else 0 end as   'M_57',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 58  then 1 else 0 end as   'M_58',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 59  then 1 else 0 end as   'M_59',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 60  then 1 else 0 end as   'M_60',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 61  then 1 else 0 end as   'M_61',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 62  then 1 else 0 end as   'M_62',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 63  then 1 else 0 end as   'M_63',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 64  then 1 else 0 end as   'M_64',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 65  then 1 else 0 end as   'M_65',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 66  then 1 else 0 end as   'M_66',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 67  then 1 else 0 end as   'M_67',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 68  then 1 else 0 end as   'M_68',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 69  then 1 else 0 end as   'M_69',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 70  then 1 else 0 end as   'M_70',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 71  then 1 else 0 end as   'M_71',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 72  then 1 else 0 end as   'M_72',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 73  then 1 else 0 end as   'M_73',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 74  then 1 else 0 end as   'M_74',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 75  then 1 else 0 end as   'M_75',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 76  then 1 else 0 end as   'M_76',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 77  then 1 else 0 end as   'M_77',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 78  then 1 else 0 end as   'M_78',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 79  then 1 else 0 end as   'M_79',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 80  then 1 else 0 end as   'M_80',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 81  then 1 else 0 end as   'M_81',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 82  then 1 else 0 end as   'M_82',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 83  then 1 else 0 end as   'M_83',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 84  then 1 else 0 end as   'M_84',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 85  then 1 else 0 end as   'M_85',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 86  then 1 else 0 end as   'M_86',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 87  then 1 else 0 end as   'M_87',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 88  then 1 else 0 end as   'M_88',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 89  then 1 else 0 end as   'M_89',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 90  then 1 else 0 end as   'M_90',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 91  then 1 else 0 end as   'M_91',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 92  then 1 else 0 end as   'M_92',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 93  then 1 else 0 end as   'M_93',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 94  then 1 else 0 end as   'M_94',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 95  then 1 else 0 end as   'M_95',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 96  then 1 else 0 end as   'M_96',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 97  then 1 else 0 end as   'M_97',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 98  then 1 else 0 end as   'M_98',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 99  then 1 else 0 end as   'M_99',    
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 100 then 1 else 0 end as   'M_100',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 101 then 1 else 0 end as   'M_101',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 102 then 1 else 0 end as   'M_102',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 103 then 1 else 0 end as   'M_103',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 104 then 1 else 0 end as   'M_104',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 105 then 1 else 0 end as   'M_105',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 106 then 1 else 0 end as   'M_106',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 107 then 1 else 0 end as   'M_107',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 108 then 1 else 0 end as   'M_108',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 109 then 1 else 0 end as   'M_109',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 110 then 1 else 0 end as   'M_110',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 111 then 1 else 0 end as   'M_111',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 112 then 1 else 0 end as   'M_112',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 113 then 1 else 0 end as   'M_113',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 114 then 1 else 0 end as   'M_114',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 115 then 1 else 0 end as   'M_115',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 116 then 1 else 0 end as   'M_116',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 117 then 1 else 0 end as   'M_117',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 118 then 1 else 0 end as   'M_118',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 119 then 1 else 0 end as   'M_119',   
case when  period_diff(date_format(G.fecha, '%Y%m'), date_format(E.fecha_inicio, '%Y%m')) + 1 = 120 then 1 else 0 end as   'M_120'    

from
gasto G
inner join gasto_x_actividad GXA on G.id = GXA.gasto_id
inner join actividad A on A.id = GXA.actividad_id
inner join actividad_x_etapa AXE on A.id = AXE.actividad_id
inner join v_etapa_diff_meses E on E.proyecto_id = A.proyecto_id and E.diff_meses = 0



union all


select 
 '       ' as tipo,'Prevision' as tipo2,concat(A.codigo ,' - ', A.descripcion) as nombre,A.resultado_id,A.id as actividad_id,A.proyecto_id, 
case when AD.mes + E.diff_meses = 1   then 1 else 0 end as   'M_1',  
case when AD.mes + E.diff_meses = 2   then 1 else 0 end as   'M_2',  
case when AD.mes + E.diff_meses = 3   then 1 else 0 end as   'M_3',  
case when AD.mes + E.diff_meses = 4   then 1 else 0 end as   'M_4',  
case when AD.mes + E.diff_meses = 5   then 1 else 0 end as   'M_5',  
case when AD.mes + E.diff_meses = 6   then 1 else 0 end as   'M_6',  
case when AD.mes + E.diff_meses = 7   then 1 else 0 end as   'M_7',  
case when AD.mes + E.diff_meses = 8   then 1 else 0 end as   'M_8',  
case when AD.mes + E.diff_meses = 9   then 1 else 0 end as   'M_9',  
case when AD.mes + E.diff_meses = 10  then 1 else 0 end as   'M_10', 
case when AD.mes + E.diff_meses = 11  then 1 else 0 end as   'M_11', 
case when AD.mes + E.diff_meses = 12  then 1 else 0 end as   'M_12', 
case when AD.mes + E.diff_meses = 13  then 1 else 0 end as   'M_13', 
case when AD.mes + E.diff_meses = 14  then 1 else 0 end as   'M_14', 
case when AD.mes + E.diff_meses = 15  then 1 else 0 end as   'M_15', 
case when AD.mes + E.diff_meses = 16  then 1 else 0 end as   'M_16', 
case when AD.mes + E.diff_meses = 17  then 1 else 0 end as   'M_17', 
case when AD.mes + E.diff_meses = 18  then 1 else 0 end as   'M_18', 
case when AD.mes + E.diff_meses = 19  then 1 else 0 end as   'M_19', 
case when AD.mes + E.diff_meses = 20  then 1 else 0 end as   'M_20', 
case when AD.mes + E.diff_meses = 21  then 1 else 0 end as   'M_21', 
case when AD.mes + E.diff_meses = 22  then 1 else 0 end as   'M_22', 
case when AD.mes + E.diff_meses = 23  then 1 else 0 end as   'M_23', 
case when AD.mes + E.diff_meses = 24  then 1 else 0 end as   'M_24', 
case when AD.mes + E.diff_meses = 25  then 1 else 0 end as   'M_25', 
case when AD.mes + E.diff_meses = 26  then 1 else 0 end as   'M_26', 
case when AD.mes + E.diff_meses = 27  then 1 else 0 end as   'M_27', 
case when AD.mes + E.diff_meses = 28  then 1 else 0 end as   'M_28', 
case when AD.mes + E.diff_meses = 29  then 1 else 0 end as   'M_29', 
case when AD.mes + E.diff_meses = 30  then 1 else 0 end as   'M_30', 
case when AD.mes + E.diff_meses = 31  then 1 else 0 end as   'M_31', 
case when AD.mes + E.diff_meses = 32  then 1 else 0 end as   'M_32', 
case when AD.mes + E.diff_meses = 33  then 1 else 0 end as   'M_33', 
case when AD.mes + E.diff_meses = 34  then 1 else 0 end as   'M_34', 
case when AD.mes + E.diff_meses = 35  then 1 else 0 end as   'M_35', 
case when AD.mes + E.diff_meses = 36  then 1 else 0 end as   'M_36', 
case when AD.mes + E.diff_meses = 37  then 1 else 0 end as   'M_37', 
case when AD.mes + E.diff_meses = 38  then 1 else 0 end as   'M_38', 
case when AD.mes + E.diff_meses = 39  then 1 else 0 end as   'M_39', 
case when AD.mes + E.diff_meses = 40  then 1 else 0 end as   'M_40', 
case when AD.mes + E.diff_meses = 41  then 1 else 0 end as   'M_41', 
case when AD.mes + E.diff_meses = 42  then 1 else 0 end as   'M_42', 
case when AD.mes + E.diff_meses = 43  then 1 else 0 end as   'M_43', 
case when AD.mes + E.diff_meses = 44  then 1 else 0 end as   'M_44', 
case when AD.mes + E.diff_meses = 45  then 1 else 0 end as   'M_45', 
case when AD.mes + E.diff_meses = 46  then 1 else 0 end as   'M_46', 
case when AD.mes + E.diff_meses = 47  then 1 else 0 end as   'M_47', 
case when AD.mes + E.diff_meses = 48  then 1 else 0 end as   'M_48', 
case when AD.mes + E.diff_meses = 49  then 1 else 0 end as   'M_49', 
case when AD.mes + E.diff_meses = 50  then 1 else 0 end as   'M_50', 
case when AD.mes + E.diff_meses = 51  then 1 else 0 end as   'M_51', 
case when AD.mes + E.diff_meses = 52  then 1 else 0 end as   'M_52', 
case when AD.mes + E.diff_meses = 53  then 1 else 0 end as   'M_53', 
case when AD.mes + E.diff_meses = 54  then 1 else 0 end as   'M_54', 
case when AD.mes + E.diff_meses = 55  then 1 else 0 end as   'M_55', 
case when AD.mes + E.diff_meses = 56  then 1 else 0 end as   'M_56', 
case when AD.mes + E.diff_meses = 57  then 1 else 0 end as   'M_57', 
case when AD.mes + E.diff_meses = 58  then 1 else 0 end as   'M_58', 
case when AD.mes + E.diff_meses = 59  then 1 else 0 end as   'M_59', 
case when AD.mes + E.diff_meses = 60  then 1 else 0 end as   'M_60', 
case when AD.mes + E.diff_meses = 61  then 1 else 0 end as   'M_61', 
case when AD.mes + E.diff_meses = 62  then 1 else 0 end as   'M_62', 
case when AD.mes + E.diff_meses = 63  then 1 else 0 end as   'M_63', 
case when AD.mes + E.diff_meses = 64  then 1 else 0 end as   'M_64', 
case when AD.mes + E.diff_meses = 65  then 1 else 0 end as   'M_65', 
case when AD.mes + E.diff_meses = 66  then 1 else 0 end as   'M_66', 
case when AD.mes + E.diff_meses = 67  then 1 else 0 end as   'M_67', 
case when AD.mes + E.diff_meses = 68  then 1 else 0 end as   'M_68', 
case when AD.mes + E.diff_meses = 69  then 1 else 0 end as   'M_69', 
case when AD.mes + E.diff_meses = 70  then 1 else 0 end as   'M_70', 
case when AD.mes + E.diff_meses = 71  then 1 else 0 end as   'M_71', 
case when AD.mes + E.diff_meses = 72  then 1 else 0 end as   'M_72', 
case when AD.mes + E.diff_meses = 73  then 1 else 0 end as   'M_73', 
case when AD.mes + E.diff_meses = 74  then 1 else 0 end as   'M_74', 
case when AD.mes + E.diff_meses = 75  then 1 else 0 end as   'M_75', 
case when AD.mes + E.diff_meses = 76  then 1 else 0 end as   'M_76', 
case when AD.mes + E.diff_meses = 77  then 1 else 0 end as   'M_77', 
case when AD.mes + E.diff_meses = 78  then 1 else 0 end as   'M_78', 
case when AD.mes + E.diff_meses = 79  then 1 else 0 end as   'M_79', 
case when AD.mes + E.diff_meses = 80  then 1 else 0 end as   'M_80', 
case when AD.mes + E.diff_meses = 81  then 1 else 0 end as   'M_81', 
case when AD.mes + E.diff_meses = 82  then 1 else 0 end as   'M_82', 
case when AD.mes + E.diff_meses = 83  then 1 else 0 end as   'M_83', 
case when AD.mes + E.diff_meses = 84  then 1 else 0 end as   'M_84', 
case when AD.mes + E.diff_meses = 85  then 1 else 0 end as   'M_85', 
case when AD.mes + E.diff_meses = 86  then 1 else 0 end as   'M_86', 
case when AD.mes + E.diff_meses = 87  then 1 else 0 end as   'M_87', 
case when AD.mes + E.diff_meses = 88  then 1 else 0 end as   'M_88', 
case when AD.mes + E.diff_meses = 89  then 1 else 0 end as   'M_89', 
case when AD.mes + E.diff_meses = 90  then 1 else 0 end as   'M_90', 
case when AD.mes + E.diff_meses = 91  then 1 else 0 end as   'M_91', 
case when AD.mes + E.diff_meses = 92  then 1 else 0 end as   'M_92', 
case when AD.mes + E.diff_meses = 93  then 1 else 0 end as   'M_93', 
case when AD.mes + E.diff_meses = 94  then 1 else 0 end as   'M_94', 
case when AD.mes + E.diff_meses = 95  then 1 else 0 end as   'M_95', 
case when AD.mes + E.diff_meses = 96  then 1 else 0 end as   'M_96', 
case when AD.mes + E.diff_meses = 97  then 1 else 0 end as   'M_97', 
case when AD.mes + E.diff_meses = 98  then 1 else 0 end as   'M_98', 
case when AD.mes + E.diff_meses = 99  then 1 else 0 end as   'M_99', 
case when AD.mes + E.diff_meses = 100 then 1 else 0 end as   'M_100',
case when AD.mes + E.diff_meses = 101 then 1 else 0 end as   'M_101',
case when AD.mes + E.diff_meses = 102 then 1 else 0 end as   'M_102',
case when AD.mes + E.diff_meses = 103 then 1 else 0 end as   'M_103',
case when AD.mes + E.diff_meses = 104 then 1 else 0 end as   'M_104',
case when AD.mes + E.diff_meses = 105 then 1 else 0 end as   'M_105',
case when AD.mes + E.diff_meses = 106 then 1 else 0 end as   'M_106',
case when AD.mes + E.diff_meses = 107 then 1 else 0 end as   'M_107',
case when AD.mes + E.diff_meses = 108 then 1 else 0 end as   'M_108',
case when AD.mes + E.diff_meses = 109 then 1 else 0 end as   'M_109',
case when AD.mes + E.diff_meses = 110 then 1 else 0 end as   'M_110',
case when AD.mes + E.diff_meses = 111 then 1 else 0 end as   'M_111',
case when AD.mes + E.diff_meses = 112 then 1 else 0 end as   'M_112',
case when AD.mes + E.diff_meses = 113 then 1 else 0 end as   'M_113',
case when AD.mes + E.diff_meses = 114 then 1 else 0 end as   'M_114',
case when AD.mes + E.diff_meses = 115 then 1 else 0 end as   'M_115',
case when AD.mes + E.diff_meses = 116 then 1 else 0 end as   'M_116',
case when AD.mes + E.diff_meses = 117 then 1 else 0 end as   'M_117',
case when AD.mes + E.diff_meses = 118 then 1 else 0 end as   'M_118',
case when AD.mes + E.diff_meses = 119 then 1 else 0 end as   'M_119',
case when AD.mes + E.diff_meses = 120 then 1 else 0 end as   'M_120' 
from actividad_detallada AD
inner join actividad A on AD.actividad_id = A.id
inner join actividad_x_etapa AXE on A.id = AXE.actividad_id
inner join v_etapa_diff_meses E on E.id = AXE.etapa_id and AD.etapa_id = E.id
inner join proyecto P on E.proyecto_id = P.id
;
		__EOI
		
		    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_cronograma_aecid` AS 
			                                                    
		select                                                
resultado_id,actividad_id,Proyecto_id,tipo2,              
Nombre as Nombre,                        
case when sum(M_1  ) = 0 then '' else 'X' end as M_1  ,                           
case when sum(M_2  ) = 0 then '' else 'X' end as M_2  ,                           
case when sum(M_3  ) = 0 then '' else 'X' end as M_3  ,                           
case when sum(M_4  ) = 0 then '' else 'X' end as M_4  ,                           
case when sum(M_5  ) = 0 then '' else 'X' end as M_5  ,                           
case when sum(M_6  ) = 0 then '' else 'X' end as M_6  ,                           
case when sum(M_7  ) = 0 then '' else 'X' end as M_7  ,                           
case when sum(M_8  ) = 0 then '' else 'X' end as M_8  ,                           
case when sum(M_9  ) = 0 then '' else 'X' end as M_9  ,                           
case when sum(M_10 ) = 0 then '' else 'X' end as M_10 ,                           
case when sum(M_11 ) = 0 then '' else 'X' end as M_11 ,                           
case when sum(M_12 ) = 0 then '' else 'X' end as M_12 ,                           
case when sum(M_13 ) = 0 then '' else 'X' end as M_13 ,                           
case when sum(M_14 ) = 0 then '' else 'X' end as M_14 ,                           
case when sum(M_15 ) = 0 then '' else 'X' end as M_15 ,                           
case when sum(M_16 ) = 0 then '' else 'X' end as M_16 ,                           
case when sum(M_17 ) = 0 then '' else 'X' end as M_17 ,                           
case when sum(M_18 ) = 0 then '' else 'X' end as M_18 ,                           
case when sum(M_19 ) = 0 then '' else 'X' end as M_19 ,                           
case when sum(M_20 ) = 0 then '' else 'X' end as M_20 ,                           
case when sum(M_21 ) = 0 then '' else 'X' end as M_21 ,                           
case when sum(M_22 ) = 0 then '' else 'X' end as M_22 ,                           
case when sum(M_23 ) = 0 then '' else 'X' end as M_23 ,                           
case when sum(M_24 ) = 0 then '' else 'X' end as M_24 ,                           
case when sum(M_25 ) = 0 then '' else 'X' end as M_25 ,                           
case when sum(M_26 ) = 0 then '' else 'X' end as M_26 ,                           
case when sum(M_27 ) = 0 then '' else 'X' end as M_27 ,                           
case when sum(M_28 ) = 0 then '' else 'X' end as M_28 ,                           
case when sum(M_29 ) = 0 then '' else 'X' end as M_29 ,                           
case when sum(M_30 ) = 0 then '' else 'X' end as M_30 ,                           
case when sum(M_31 ) = 0 then '' else 'X' end as M_31 ,                           
case when sum(M_32 ) = 0 then '' else 'X' end as M_32 ,                           
case when sum(M_33 ) = 0 then '' else 'X' end as M_33 ,                           
case when sum(M_34 ) = 0 then '' else 'X' end as M_34 ,                           
case when sum(M_35 ) = 0 then '' else 'X' end as M_35 ,                           
case when sum(M_36 ) = 0 then '' else 'X' end as M_36 ,                           
case when sum(M_37 ) = 0 then '' else 'X' end as M_37 ,                           
case when sum(M_38 ) = 0 then '' else 'X' end as M_38 ,                           
case when sum(M_39 ) = 0 then '' else 'X' end as M_39 ,                           
case when sum(M_40 ) = 0 then '' else 'X' end as M_40 ,                           
case when sum(M_41 ) = 0 then '' else 'X' end as M_41 ,                           
case when sum(M_42 ) = 0 then '' else 'X' end as M_42 ,                           
case when sum(M_43 ) = 0 then '' else 'X' end as M_43 ,                           
case when sum(M_44 ) = 0 then '' else 'X' end as M_44 ,                           
case when sum(M_45 ) = 0 then '' else 'X' end as M_45 ,                           
case when sum(M_46 ) = 0 then '' else 'X' end as M_46 ,                           
case when sum(M_47 ) = 0 then '' else 'X' end as M_47 ,                           
case when sum(M_48 ) = 0 then '' else 'X' end as M_48 ,                           
case when sum(M_49 ) = 0 then '' else 'X' end as M_49 ,                           
case when sum(M_50 ) = 0 then '' else 'X' end as M_50 ,                           
case when sum(M_51 ) = 0 then '' else 'X' end as M_51 ,                           
case when sum(M_52 ) = 0 then '' else 'X' end as M_52 ,                           
case when sum(M_53 ) = 0 then '' else 'X' end as M_53 ,                           
case when sum(M_54 ) = 0 then '' else 'X' end as M_54 ,                           
case when sum(M_55 ) = 0 then '' else 'X' end as M_55 ,                           
case when sum(M_56 ) = 0 then '' else 'X' end as M_56 ,                           
case when sum(M_57 ) = 0 then '' else 'X' end as M_57 ,                           
case when sum(M_58 ) = 0 then '' else 'X' end as M_58 ,                           
case when sum(M_59 ) = 0 then '' else 'X' end as M_59 ,                           
case when sum(M_60 ) = 0 then '' else 'X' end as M_60 ,                           
case when sum(M_61 ) = 0 then '' else 'X' end as M_61 ,                           
case when sum(M_62 ) = 0 then '' else 'X' end as M_62 ,                           
case when sum(M_63 ) = 0 then '' else 'X' end as M_63 ,                           
case when sum(M_64 ) = 0 then '' else 'X' end as M_64 ,                           
case when sum(M_65 ) = 0 then '' else 'X' end as M_65 ,                           
case when sum(M_66 ) = 0 then '' else 'X' end as M_66 ,                           
case when sum(M_67 ) = 0 then '' else 'X' end as M_67 ,                           
case when sum(M_68 ) = 0 then '' else 'X' end as M_68 ,                           
case when sum(M_69 ) = 0 then '' else 'X' end as M_69 ,                           
case when sum(M_70 ) = 0 then '' else 'X' end as M_70 ,                           
case when sum(M_71 ) = 0 then '' else 'X' end as M_71 ,                           
case when sum(M_72 ) = 0 then '' else 'X' end as M_72 ,                           
case when sum(M_73 ) = 0 then '' else 'X' end as M_73 ,                           
case when sum(M_74 ) = 0 then '' else 'X' end as M_74 ,                           
case when sum(M_75 ) = 0 then '' else 'X' end as M_75 ,                           
case when sum(M_76 ) = 0 then '' else 'X' end as M_76 ,                           
case when sum(M_77 ) = 0 then '' else 'X' end as M_77 ,                           
case when sum(M_78 ) = 0 then '' else 'X' end as M_78 ,                           
case when sum(M_79 ) = 0 then '' else 'X' end as M_79 ,                           
case when sum(M_80 ) = 0 then '' else 'X' end as M_80 ,                           
case when sum(M_81 ) = 0 then '' else 'X' end as M_81 ,                           
case when sum(M_82 ) = 0 then '' else 'X' end as M_82 ,                           
case when sum(M_83 ) = 0 then '' else 'X' end as M_83 ,                           
case when sum(M_84 ) = 0 then '' else 'X' end as M_84 ,                           
case when sum(M_85 ) = 0 then '' else 'X' end as M_85 ,                           
case when sum(M_86 ) = 0 then '' else 'X' end as M_86 ,                           
case when sum(M_87 ) = 0 then '' else 'X' end as M_87 ,                           
case when sum(M_88 ) = 0 then '' else 'X' end as M_88 ,                           
case when sum(M_89 ) = 0 then '' else 'X' end as M_89 ,                           
case when sum(M_90 ) = 0 then '' else 'X' end as M_90 ,                           
case when sum(M_91 ) = 0 then '' else 'X' end as M_91 ,                           
case when sum(M_92 ) = 0 then '' else 'X' end as M_92 ,                           
case when sum(M_93 ) = 0 then '' else 'X' end as M_93 ,                           
case when sum(M_94 ) = 0 then '' else 'X' end as M_94 ,                           
case when sum(M_95 ) = 0 then '' else 'X' end as M_95 ,                           
case when sum(M_96 ) = 0 then '' else 'X' end as M_96 ,                           
case when sum(M_97 ) = 0 then '' else 'X' end as M_97 ,                           
case when sum(M_98 ) = 0 then '' else 'X' end as M_98 ,                           
case when sum(M_99 ) = 0 then '' else 'X' end as M_99 ,                           
case when sum(M_100) = 0 then '' else 'X' end as M_100,                           
case when sum(M_101) = 0 then '' else 'X' end as M_101,                           
case when sum(M_102) = 0 then '' else 'X' end as M_102,                           
case when sum(M_103) = 0 then '' else 'X' end as M_103,                           
case when sum(M_104) = 0 then '' else 'X' end as M_104,                           
case when sum(M_105) = 0 then '' else 'X' end as M_105,                           
case when sum(M_106) = 0 then '' else 'X' end as M_106,                           
case when sum(M_107) = 0 then '' else 'X' end as M_107,                           
case when sum(M_108) = 0 then '' else 'X' end as M_108,                           
case when sum(M_109) = 0 then '' else 'X' end as M_109,                           
case when sum(M_110) = 0 then '' else 'X' end as M_110,                           
case when sum(M_111) = 0 then '' else 'X' end as M_111,                           
case when sum(M_112) = 0 then '' else 'X' end as M_112,                           
case when sum(M_113) = 0 then '' else 'X' end as M_113,                           
case when sum(M_114) = 0 then '' else 'X' end as M_114,                           
case when sum(M_115) = 0 then '' else 'X' end as M_115,                           
case when sum(M_116) = 0 then '' else 'X' end as M_116,                           
case when sum(M_117) = 0 then '' else 'X' end as M_117,                           
case when sum(M_118) = 0 then '' else 'X' end as M_118,                           
case when sum(M_119) = 0 then '' else 'X' end as M_119,                           
case when sum(M_120) = 0 then '' else 'X' end as M_120                            
                                                     
  from                                                    
 v_listado_resultados_actividades_cronograma_aecid A      
group by 
resultado_id,actividad_id,Proyecto_id,tipo2,Tipo,Nombre 

;                                                          


		__EOI
		
		
		    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_ejecucion_gasto_informe_final_aecid` AS 

select 
PF.proyecto_id,
PF.id as partida_proyecto_id,
PF.nombre as partida_proyecto_nombre,
IFNULL(sum(T.importe_moneda_base),0) as importe 
FROM


partida_financiacion PF
inner join v_fechas_informe_aecid E on PF.proyecto_id = E.proyecto_id
left join v_gasto T on PF.proyecto_id = T.proyecto_id and T.partida_proyecto_id = PF.id
and  T.financiador_nombre = 'AECID' and T.fecha BETWEEN E.fecha_E3_ini and E.fecha_E3_fin 
group BY
PF.proyecto_id,PF.nombre,PF.id
order by PF.id
;
		__EOI
		
		    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_ejecucion_gasto_informe_final_no_aecid` AS 

select 
PF.proyecto_id,
PF.id as partida_proyecto_id,
PF.nombre as partida_proyecto_nombre,
IFNULL(sum(T.importe_moneda_base),0) as importe 
FROM


partida_financiacion PF
inner join v_fechas_informe_aecid E on PF.proyecto_id = E.proyecto_id
left join v_gasto T on PF.proyecto_id = T.proyecto_id and T.partida_proyecto_id = PF.id
and  T.financiador_nombre <> 'AECID' and T.fecha BETWEEN E.fecha_E3_ini and E.fecha_E3_fin 
group BY
PF.proyecto_id,PF.nombre,PF.id
order by PF.id
;
		__EOI
		
		
		    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_ejecucion_gasto_primer_informe_aecid` AS 

select 
PF.proyecto_id,
PF.id as partida_proyecto_id,
PF.nombre as partida_proyecto_nombre,
IFNULL(sum(T.importe_moneda_base),0) as importe 
FROM


partida_financiacion PF
inner join v_fechas_informe_aecid E on PF.proyecto_id = E.proyecto_id
left join v_gasto T on PF.proyecto_id = T.proyecto_id and T.partida_proyecto_id = PF.id
and  T.financiador_nombre = 'AECID' and T.fecha BETWEEN E.fecha_E1_ini and E.fecha_E1_fin 
group BY
PF.proyecto_id,PF.nombre,PF.id
order by PF.id
;
		__EOI
		
		
		    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_ejecucion_gasto_primer_informe_no_aecid` AS 

select 
PF.proyecto_id,
PF.id as partida_proyecto_id,
PF.nombre as partida_proyecto_nombre,
IFNULL(sum(T.importe_moneda_base),0) as importe 
FROM


partida_financiacion PF
inner join v_fechas_informe_aecid E on PF.proyecto_id = E.proyecto_id
left join v_gasto T on PF.proyecto_id = T.proyecto_id and T.partida_proyecto_id = PF.id
and  T.financiador_nombre <> 'AECID' and T.fecha BETWEEN E.fecha_E1_ini and E.fecha_E1_fin 
group BY
PF.proyecto_id,PF.nombre,PF.id
order by PF.id
;
		__EOI
		
		
		    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_ejecucion_gasto_segundo_informe_aecid` AS 

select 
PF.proyecto_id,
PF.id as partida_proyecto_id,
PF.nombre as partida_proyecto_nombre,
IFNULL(sum(T.importe_moneda_base),0) as importe 
FROM


partida_financiacion PF
inner join v_fechas_informe_aecid E on PF.proyecto_id = E.proyecto_id
left join v_gasto T on PF.proyecto_id = T.proyecto_id and T.partida_proyecto_id = PF.id
and  T.financiador_nombre = 'AECID' and T.fecha BETWEEN E.fecha_E2_ini and E.fecha_E2_fin 
group BY
PF.proyecto_id,PF.nombre,PF.id
order by PF.id
;
		__EOI
  
  		    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_ejecucion_gasto_segundo_informe_no_aecid` AS 

select 
PF.proyecto_id,
PF.id as partida_proyecto_id,
PF.nombre as partida_proyecto_nombre,
IFNULL(sum(T.importe_moneda_base),0) as importe 
FROM


partida_financiacion PF
inner join v_fechas_informe_aecid E on PF.proyecto_id = E.proyecto_id
left join v_gasto T on PF.proyecto_id = T.proyecto_id and T.partida_proyecto_id = PF.id
and  T.financiador_nombre <> 'AECID' and T.fecha BETWEEN E.fecha_E2_ini and E.fecha_E2_fin 
group BY
PF.proyecto_id,PF.nombre,PF.id
order by PF.id
;
		__EOI
		

		
				    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_listado_gastos_x_proyecto_aecid` AS 


select 
GASTOXP.proyecto_id,
convert(GASTO.id,char(50)) as id,
IFNULL(GASTO.fecha,'') as fecha,
IFNULL(emisor_factura,'') as emisor_factura,IFNULL(concepto,'') as concepto,
concat(PF.codigo,' ',PF.nombre) as partida,
convert(IFNULL(
(select sum(importe_moneda_base) from v_gasto where gasto_id = GASTO.id)
,0),char(50)) as importe,
convert(IFNULL(TCG.tasa_cambio,0),char(50)) as Tasa_cambio_divisa,
'' as Tasa_cambio_euro,
convert(IFNULL(
(select sum(importe_moneda_base) from v_gasto where financiador_nombre = 'AECID' and gasto_id = GASTO.id)
,0),char(50)) as Importe_AECID ,
convert(IFNULL(
(select sum(importe_moneda_base) from v_gasto where financiador_id = implementador_id and gasto_id = GASTO.id)
,0),char(50)) as Importe_ONGD ,
convert(IFNULL(
(select sum(importe_moneda_base) from v_gasto where financiador_nombre <> 'AECID' and financiador_id <> implementador_id and gasto_id = GASTO.id)
,0),char(50)) as Importe_OTROS
from gasto GASTO
inner join partida PF on GASTO.partida_id = PF.id
inner join gasto_x_proyecto GASTOXP on GASTOXP.gasto_id = GASTO.id 
left join tasa_cambio_gasto TCG on GASTO.id = TCG.gasto_id and TCG.proyecto_id = GASTOXP.proyecto_id
;
		__EOI
		
		
				    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_presupuesto` AS 


select 
A.id as financiador_id,A.nombre as financiador_nombre,
AC.id as actividad_id,AC.codigo as actividad_codigo,AC.descripcion as actividad_nombre,
P.agente_id as implementador_id, AIMP.nombre as implementador_nombre,
PY.id as proyecto_id, PY.nombre as proyecto_nombre,
E.id as etapa_id,E.nombre as etapa_nombre,
PT.id as partida_id,PT.nombre as partida_nombre,
PTF.id as partida_proyecto_id,PTF.nombre as partida_proyecto_nombre,
P.id as presupuesto_id,
P.moneda_id as moneda_id,
M.abreviatura as moneda_nombre,
PY.moneda_id as moneda_base_id,
MAUX.nombre as moneda_base_nombre,
case when P.tasa_cambio = 0 then 1 else IFNULL(P.tasa_cambio,1) end as tasa_cambio,
((PXA.importe * PXAC.importe)/P.importe) as importe,
((PXA.importe * PXAC.importe)/P.importe) * 
(case when P.tasa_cambio = 0 then 1 else IFNULL(P.tasa_cambio,1) end) as importe_moneda_base

from 
presupuesto_x_agente PXA
inner join presupuesto_x_actividad PXAC on PXA.presupuesto_id = PXAC.presupuesto_id
inner join agente A on PXA.agente_id = A.id
inner join actividad AC on PXAC.actividad_id = AC.id
inner join presupuesto P on PXA.presupuesto_id = P.id
inner join moneda M on P.moneda_id = M.id
inner join agente AIMP on P.agente_id = AIMP.id
inner join proyecto PY on P.proyecto_id = PY.id
left join moneda MAUX on MAUX.id = PY.moneda_id
inner join etapa E on E.proyecto_id = PY.id and P.etapa_id = E.id
inner join partida PT on P.partida_id = PT.id
left join partida_x_partida_financiacion PXPA on PT.id = PXPA.partida_id
left join partida_financiacion PTF on PTF.id = PXPA.partida_financiacion_id
;
		__EOI
		
		
				    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_presupuesto_detallado` AS 


select 
A.id as financiador_id,A.nombre as financiador_nombre,
AC.id as actividad_id,AC.codigo as actividad_codigo,AC.descripcion as actividad_nombre,
P.agente_id as implementador_id, AIMP.nombre as implementador_nombre,
PY.id as proyecto_id, PY.nombre as proyecto_nombre,
PT.id as partida_id,PT.nombre as partida_nombre,
PTF.id as partida_proyecto_id,PTF.nombre as partida_proyecto_nombre,
P.id as presupuesto_id,
P.moneda_id as moneda_id,
M.abreviatura as moneda_nombre,
PY.moneda_id as moneda_base_id,
MAUX.nombre as moneda_base_nombre,
case when P.tasa_cambio = 0 then 1 else IFNULL(P.tasa_cambio,1) end  as tasa_cambio,
PD.fecha_inicio,
PD.fecha_fin,
PD.mes,
(PD.importe * ((PXA.importe * PXAC.importe)/P.importe))/P.importe as importe,
((PD.importe * ((PXA.importe * PXAC.importe)/P.importe))/P.importe) * 
(case when P.tasa_cambio = 0 then 1 else IFNULL(P.tasa_cambio,1) end) as importe_moneda_base

from 
presupuesto_x_agente PXA
inner join presupuesto_x_actividad PXAC on PXA.presupuesto_id = PXAC.presupuesto_id
inner join agente A on PXA.agente_id = A.id
inner join actividad AC on PXAC.actividad_id = AC.id
inner join presupuesto P on PXA.presupuesto_id = P.id
inner join presupuesto_detallado PD on P.id = PD.presupuesto_id
inner join moneda M on P.moneda_id = M.id
inner join agente AIMP on P.agente_id = AIMP.id
inner join proyecto PY on P.proyecto_id = PY.id
left join moneda MAUX on MAUX.id = PY.moneda_id
inner join partida PT on P.partida_id = PT.id
left join partida_x_partida_financiacion PXPA on PT.id = PXPA.partida_id
left join partida_financiacion PTF on PTF.id = PXPA.partida_financiacion_id
;
		__EOI
		

  end

  def self.down
  	execute "DROP VIEW IF EXISTS `v_etapa_diff_meses`;"
  	execute "DROP VIEW IF EXISTS `v_fechas_informe_aecid`;"
  	execute "DROP VIEW IF EXISTS `v_cabecera_cronograma`;"
  	execute "DROP VIEW IF EXISTS `v_listado_resultados_actividades_cronograma_aecid`;"
  	execute "DROP VIEW IF EXISTS `v_cronograma_aecid`;  "
  	execute "DROP VIEW IF EXISTS `v_ejecucion_gasto_informe_final_aecid`;"
  	execute "DROP VIEW IF EXISTS `v_ejecucion_gasto_informe_final_no_aecid`;"
  	execute "DROP VIEW IF EXISTS `v_ejecucion_gasto_primer_informe_aecid`;"
  	execute "DROP VIEW IF EXISTS `v_ejecucion_gasto_primer_informe_no_aecid`;"
  	execute "DROP VIEW IF EXISTS `v_ejecucion_gasto_segundo_informe_aecid`;"
  	execute "DROP VIEW IF EXISTS `v_ejecucion_gasto_segundo_informe_no_aecid`;"
  	execute "DROP VIEW IF EXISTS `v_listado_gastos_x_proyecto_aecid`;"
  	execute "DROP VIEW IF EXISTS `v_presupuesto`;"
  	execute "DROP VIEW IF EXISTS `v_presupuesto_detallado`;" 	
  end
end
