class SubpartidasEnVistaGasto < ActiveRecord::Migration
  def self.up

    execute "DROP VIEW IF EXISTS `v_gasto_agente`;"

    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_gasto_agente` AS 

select 
A.id as implementador_id, A.nombre as implementador_nombre,
PT.id as partida_id,PT.nombre as partida_nombre,
G.id as gasto_id,
G.moneda_id as moneda_id,
M.abreviatura as moneda_nombre,
A.moneda_id as moneda_base_id,
MAUX.nombre as moneda_base_nombre,
IFNULL(TCG.tasa_cambio,0) as tasa_cambio,
SP.id as subpartida_id,
SP.nombre as subpartida_nombre,
G.fecha,
G.importe as importe,
G.importe * IFNULL(TCG.tasa_cambio,0) as importe_moneda_base

from gasto G
inner join agente A on A.id = G.agente_id
inner join moneda M on G.moneda_id = M.id
inner join partida PT on G.partida_id = PT.id
inner join moneda MAUX on MAUX.id = A.moneda_id
left join tasa_cambio_gasto TCG on TCG.gasto_id = G.id and TCG.agente_id = A.id
left join subpartida SP on SP.id = G.subpartida_agente_id 
;
__EOI

  end

  def self.down
    execute "DROP VIEW IF EXISTS `v_gasto_agente`;"
  end
end
